/* akirom.h
   
   ץȥ
   $Id: akirom.h,v 1.1.1.1 2014/08/07 05:18:42 nobu-s Exp $
*/

/*
@(#)COPYRIGHT	8.2 (Berkeley) 3/21/94

The software known as AKI-ROM饤楽ե(UNIX) is distributed 
under the following terms:

Copyright (c) 1994-2014 Nobuyoshi Sato. All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:
1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.
*/


#ifndef AKIROM_H
#define AKIROM_H


#include <stdio.h>

/* ޥɥ饤ǻꤵ줿operationμ */
#define OPERATION_NONE			0
#define OPERATION_TRANSMIT		1  /* AKI80RAM˥ǡ */
#define OPERATION_TRANSMIT_WRITE	2  /* 嵭+ROMؤν񤭹 */
#define OPERATION_WRITE			3  /* AKI80RAMROM˽񤭹 */
#define OPERATION_READ			4  /* AKI80RAMROMɤ߹ */
#define OPERATION_RECEIVE		5  /* AKI80RAMǡ */
#define OPERATION_READ_RECEIVE		6  /* ROMɤ߹+ǡ */
#define OPERATION_COMPARE		7  /* AKI80RAMROMΥǡ */
#define OPERATION_COMPARE_HOST		8  /* ɤ߹եȥǡ */
#define OPERATION_BLANK_CHECK		9  /* ROMõѤ߲ɤå */
#define OPERATION_CHECKSUM		10 /* AKI80RAMΥå */

/* ե */
#define FILE_FORMAT_NONE	0x0	/* ̤ */
#define FILE_FORMAT_HEX		0x1	/* ƥHEX */
#define FILE_FORMAT_BIN		0x2	/* ΥХʥ */

/* ǥեȤΥǡ(֥󥯻) */
#define BLANK_DATA		0xff

/* 楽ե¦ΥեžѥХåե */
#define DATA_BUF_SIZE		0x8000

/* AKI-ROM饤Ȥ̿ؿ֤
 * 00x7fffϼԤɥ쥹ɥ쥹out of band֤ͤͤȤ
 */
#define COMM_SUCCEED		-1	/*  */
#define COMM_TRANSMIT_FAIL	-2	/* ǽ */
#define COMM_RECEIVE_FAIL	-3	/* ǽ */
#define COMM_NOT_AKIROM		-4	/* AKI-ROM饤ʳĤʤäƤ */
#define COMM_CHECKSUM_ERROR	-5	/* å԰ */
#define COMM_MEMORY_ALLOC_ERROR	-6	/* ݼ */


/* ROMμ */
#define AKI_ROM_2764		0x10	/* ROM饤ROMμ */
#define AKI_ROM_27128		0x20
#define AKI_ROM_27256		0x30
#define AKI_ROM_2864		0x40
#define AKI_ROM_NONE		0x00	/* ROM̤ꡣROM饤ؤʤ */

/* AKI-80륳ޥ */
#define AKI_TRANSMIT_WRITE	1
#define AKI_WRITE_AKIRAM	2
#define AKI_TRANSMIT_AKIRAM	3
#define AKI_READ_RECEIVE	4
#define AKI_READ_AKIRAM		5
#define AKI_COMPARE_HOSTDATA	6
#define AKI_COMPARE_AKIRAM	7
#define AKI_BLANK_CHECK		8
#define AKI_CHECKSUM		9

#ifndef YES
#define YES 1
#endif
#ifndef NO
#define NO 0
#endif

struct ROM_ADDR {			/* ROM˽񤭹ॢɥ쥹ϰ */
    unsigned int start;			/* ϥɥ쥹 */
    unsigned int end;			/* λɥ쥹 */
};

/* ѿ */
/* main.c */
#ifndef MAIN_C
extern unsigned char *data_buf;
extern int rom_type;
extern struct ROM_ADDR rom_addr;
extern int file_loaded;
/*extern int akiram_loaded;*/
#endif	/* MAIN_C */



/* ؿ */
/* serial.c */
int init_serial(char *);	/* ǥХե̾ */
int close_serial(void);		/* ᤷƽλ */
void enable_serial(void);	/* DTRRTS */
void disable_serial(void);	/* DTRRTS */
int receive_serial(unsigned char *, unsigned int);
				/* (ॢ2) */
int trans_serial(unsigned char *, unsigned int);
				/*  */

/* communicate.c */
int blank_check(void);		/* ֥󥯥åԤ */
int compare_aki_ram(void);	/* ROM饤RAMȤ */
int read_aki_ram(void);		/* ROM饤RAMؤΥǡɤߤ */
int write_aki_ram(void);	/* ROM饤RAMν񤭹 */
int trans_aki_ram(void);	/* ROM饤RAMؤž */
int read_receive(void);		/* ROMǡɤߤƼ */
int checksum(void);		/* åǧ */
int compare_host_data(void);	/* ROMΥǡȥۥȤΥǡӤ */




/* main.c */
int init_all(void);		/* Ƥѿʤɤ */
int end_all(void);
void enable_setugid(void);	/* 桼ID碌 */
void disable_setugid(void);	



/* menu.c */
int menu(void);			/* ᥤ˥塼 */

/* file.c */
int load_hex(FILE *, unsigned int);
				/* HEXե */
int save_hex(FILE*, unsigned int);
				/* HEXեǥ */
int load_bin(FILE *, unsigned int);
				/* Хʥե */
int save_bin(FILE *, unsigned int);
				/* Хʥե򥻡 */




#endif		/* AKIROM_H */
