/* AKI-ROM饤ؤΥޥȷ̤γǧʤ
 * $Id: communicate.c,v 1.1.1.1 2014/08/07 05:18:42 nobu-s Exp $
 */

/*
@(#)COPYRIGHT	8.2 (Berkeley) 3/21/94

The software known as AKI-ROM饤楽ե(UNIX) is distributed 
under the following terms:

Copyright (c) 1994-2014 Nobuyoshi Sato. All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:
1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.
*/

#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#define COMMUNICATE_C
#include "config.h"
#include "akirom.h"

#define QUESTION_MSG "Are You AKI-80 ?\x0d\x0a"
#define ANSWER_MSG "Yes My Name is AKI-80"
#define COMMAND 0
#define START_ADDR_H	1
#define START_ADDR_L	2
#define TRANS_BYTE_H	3
#define TRANS_BYTE_L	4

/* ROM饤ǡ˰٤Хȿ */
#define DEFAULT_TRANSFER_UNIT	64


/* ΥեΤߤδؿ¾ϸƤФʤ */
static int send_command(int);		/* AKI80ǧƥޥɤ */


/* ꤬̿ROM饤Ǥ뤫ǧƥޥɤ
 * 	COM_SUCCED		
 *		COM_TRANSMIT_FAIL	ǽ
 *		COM_RECEIVE_FAIL	ǽ
 *		COM_NOT_AKIROM		AKI-ROM饤ʳĤʤäƤ
 */
static int send_command(int kbd_cmd)
{
    unsigned char cmd[5];
    char answer[30];
    int question_len;
    int answer_len;
    unsigned int trans_byte;

    int i;

    question_len = strlen(QUESTION_MSG);
    answer_len = strlen(ANSWER_MSG);

    if (trans_serial(QUESTION_MSG, question_len) <= 0){
	return COMM_TRANSMIT_FAIL;	/* Ǥʤ */
    }
    if (receive_serial(answer, answer_len) <= 0){
	return COMM_RECEIVE_FAIL;		/* Ǥʤ */
    }
    answer[answer_len] = (char)0;	/* ߥ͡ */

    if (strncmp(ANSWER_MSG, answer, answer_len) != 0){
	return COMM_NOT_AKIROM;		/* ROM饤ʳĤʤäƤ */
    }
    switch (rom_type){
      case AKI_ROM_2764:
	cmd[COMMAND] = (unsigned char)AKI_ROM_2764 | kbd_cmd;
	break;
      case AKI_ROM_27128:
	cmd[COMMAND] = (unsigned char)AKI_ROM_27128 | kbd_cmd;
	break;
      case AKI_ROM_27256:
	cmd[COMMAND] = (unsigned char)AKI_ROM_27256 | kbd_cmd;
	break;
      case AKI_ROM_2864:
	if (kbd_cmd == AKI_TRANSMIT_WRITE || kbd_cmd == AKI_WRITE_AKIRAM){
	    cmd[COMMAND] = (unsigned char)AKI_ROM_2864 | kbd_cmd;
	} else {
	    cmd[COMMAND] = (unsigned char)AKI_ROM_2764 | kbd_cmd;
	}
	break;
    }

    cmd[START_ADDR_H] = (unsigned char)(rom_addr.start >> 8);
    cmd[START_ADDR_L] = (unsigned char)(rom_addr.start & 0xff);
    trans_byte = rom_addr.end - rom_addr.start + 1;
    cmd[TRANS_BYTE_H] = (unsigned char)(trans_byte >> 8);
    cmd[TRANS_BYTE_L] = (unsigned char)(trans_byte & 0xff);

/*
    printf("sending: ");
    for (i =0; i < 5; i++){
	printf("%02x ", cmd[i]);
    }
    printf("\n");
*/
    if (trans_serial(cmd, 5) <= 0){
	return COMM_TRANSMIT_FAIL;		/* ǽ */
    }
    return COMM_SUCCEED;
}

/* ROM饤RAMΥåȥۥȤΥǡХåեΥåӤ
 * 	COMM_SUCCEED		
 *		COMM_CHECKSUM_ERROR	԰
 *		COMM_TRANSMIT_FAIL	ǽ
 *		COMM_RECEIVE_FAIL	ǽ
 *		COMM_NOT_AKIROM		ROM饤ĤʤäƤʤ
 */
int checksum(void)
{
    int i;
    int ret;
    unsigned char receive_data[3];
    unsigned int chksum_host = 0;
    unsigned int chksum_aki = 0;

    for (i = rom_addr.start; i < rom_addr.end + 1; i++){
	chksum_host += data_buf[i];
    }
    chksum_host &= 0xffff;

    enable_serial();

    if ((ret = send_command(AKI_CHECKSUM)) != COMM_SUCCEED){	/* ̿ */
	disable_serial();
	printf("result = %d\n", ret);
	return ret;
    }
    if (receive_serial(receive_data, 2) != 2){/* ԡ2Х֤ä */
	disable_serial();
	return COMM_RECEIVE_FAIL;
    }
    
    disable_serial();

    chksum_aki = ((unsigned int)receive_data[0] << 8)
      					| (unsigned int)receive_data[1];

    if (chksum_aki == chksum_host){
	return COMM_SUCCEED;
    } else {
	return COMM_CHECKSUM_ERROR;
    }
}

/* ֥󥯥å
 * 	COMM_SUCCEED		֥
 *		COMM_TRANSMIT_FAIL	ǽ
 *		COMM_RECEIVE_FAIL	ǽ
 *		COMM_NOT_AKIROM		ROM饤ĤʤäƤʤ
 *		¾		ROMϥ֥󥯤ǤϤʤʼԤɥ쥹
 */
int blank_check(void)
{
    unsigned char receive_data[3];
    unsigned int result;
    int ret;

    enable_serial();

    if ((ret = send_command(AKI_BLANK_CHECK)) != COMM_SUCCEED){/* ̿ */
	disable_serial();
	perror("blank_check(): cannot send commnad");
	return ret;
    }
    if (receive_serial(receive_data, 2) != 2){		/*  */
	disable_serial();
	perror("blank_check(): cannot recieve result");
	return COMM_RECEIVE_FAIL;
    }
    
    disable_serial();

    				/* ̥ХȤä餷 */
    				/* (Ϸ)     big endian? */
    result = ((unsigned int)receive_data[0] << 8)
      					| (unsigned int)receive_data[1];
    if (result == 0){		/* ֥󥯥åη̤äƤ */
	return COMM_SUCCEED;	/* 0Хܤ֥󥯤ʤä */
    } else {
	return result;		/* ֥󥯤Ǥʤ硢Υɥ쥹 */
    }
}

/* ROMROM饤RAM
 * 	COMM_SUCCEED		
 *		COMM_TRANSMIT_FAIL	ǽ
 *		COMM_RECEIVE_FAIL	ǽ
 *		COMM_NOT_AKIROM		ROM饤ĤʤäƤʤ
 *		¾			԰סʼԤɥ쥹
 */
int compare_aki_ram(void)
{
    unsigned char receive_data[3];
    unsigned int result;
    int ret;
   
    enable_serial();

    if ((ret = send_command(AKI_COMPARE_AKIRAM)) != COMM_SUCCEED){
	/* ̿ */
	disable_serial();
	return ret;
    }
    if (receive_serial(receive_data, 2) != 2){		/*  */
	disable_serial();
	return COMM_RECEIVE_FAIL;
    }
    
    disable_serial();
    
    				/* ̥ХȤä餷 */
    				/* (Ϸ)     big endian? */
    result = ((unsigned int)receive_data[0] << 8)
      					| (unsigned int)receive_data[1];
    if (result == 0){		/* ROMRAMӤη̤äƤ */
	return COMM_SUCCEED;	/* 0Хܤ԰פξ */
    } else {
	return result;		/* ԰פξ硢Υɥ쥹 */
    }
}

/* ROM饤RAMؤΥǡɤߤ
 * 	COMM_SUCCEED		
 *		COMM_TRANSMIT_FAIL	ǽ
 *		COMM_RECIEVE_FAIL	ǽ
 *		COMM_NOT_AKIROM		ROM饤ĤʤäƤʤ
 *		¾			ԡʼԤɥ쥹
 */
int read_aki_ram(void)
{
    unsigned char receive_data[3];
    unsigned int result;
    int ret;

    enable_serial();

    if ((ret = send_command(AKI_READ_AKIRAM)) != COMM_SUCCEED){	/* ̿ */
	disable_serial();
	return ret;
    }
    if (receive_serial(receive_data, 2) != 2){		/*  */
	disable_serial();
	return COMM_RECEIVE_FAIL;
    }
    
    disable_serial();

    				/* ̥ХȤä餷 */
    				/* (Ϸ)     big endian? */
    result = ((unsigned int)receive_data[0] << 8)
      					| (unsigned int)receive_data[1];

    if (result == 0){		/* ɤ߽ФԤɥ쥹äƤ */
	return COMM_SUCCEED;	/* 0ХܤǼԾ */
    } else {
	return result;		/* ɤ߽ФԤ硢Υɥ쥹 */
    }
}

/* ROM饤RAMROM˽񤭹
 * 	COMM_SUCCEED		
 *		COMM_TRANSMIT_FAIL	ǽ
 *		COMM_RECEIVE_FAIL	ǽ
 *		COMM_NOT_AKIROM		ROM饤ĤʤäƤʤ
 *		¾			ԡʼԤɥ쥹
 */
int write_aki_ram(void)
{
    unsigned char result;
    int wrote;
    int ret;

    enable_serial();
    if ((ret = send_command(AKI_WRITE_AKIRAM)) != COMM_SUCCEED){ /*  */
	disable_serial();
	return ret;
    }
    wrote = rom_addr.start;
    do {
	if (receive_serial(&result, 1) != 1){		/*  */
	    disable_serial();
	    return COMM_RECEIVE_FAIL;
	}
	wrote += 16;
	printf(".");
	fflush(stdout);
    } while (result == 0 || result == 0xff);
    printf("\n");
    disable_serial();

    if (result == 0){
	return COMM_SUCCEED;
    } else {
	return wrote;		/* Ԥɥ쥹 */
    }
}

/* ROM饤RAMإǡž
 * 	COMM_SUCCEED		
 *		COMM_TRANSMIT_FAIL	ǽ
 *		COMM_RECEIVE_FAIL	ǽ
 *		COMM_NOT_AKIROM		ROM饤ĤʤäƤʤ
 *		COMM_CHECKSUM_ERROR	å२顼
 *		¾			̿˥顼ȯʼԤɥ쥹
 */
int trans_aki_ram(void)
{
    int addr;
    int ret;
    int cont = 1;
    int trans_unit = DEFAULT_TRANSFER_UNIT;

    enable_serial();

    /* ž򳫻Ϥ륳ޥɤ */
    if ((ret = send_command(AKI_TRANSMIT_AKIRAM)) != COMM_SUCCEED){
	disable_serial();
	return ret;
    }

    /* 64ХȤž롣PC98Ǥν楽եȤϤޤȤž */
    addr = rom_addr.start;
    printf(".");
    fflush(stdout);
    while (cont){
	if (addr > rom_addr.end - DEFAULT_TRANSFER_UNIT){
	    cont = 0;
	    trans_unit = rom_addr.end + 1 - addr;
	}
	if (trans_serial(data_buf + addr, trans_unit) != trans_unit){
	    disable_serial();
	    return addr;	/* Ԥɥ쥹 */
	}
	addr += trans_unit;
	printf(".");
	fflush(stdout);
    }

    disable_serial();

    return checksum();
}


/* ROM饤RAM˥ǡž֥󥯥åԤROM˽񤭹
 * ֤	COMM_SUCCEED		
 *		COMM_TRANSMIT_FAIL	ǽ
 *		COMM_RECEIVE_FAIL	ǽ
 *		COMM_NOT_AKIROM		ROM饤ĤʤäƤʤ
 *		COMM_CHECKSUM_ERROR	å२顼
 *		¾			̿˥顼ȯʼԤɥ쥹
 */
void transmit_write(void)
{
    /* PC98楽եȤΥˤȡ
     * 1. ֥󥯥åޥɤۥȤ
     * 2. ֥󥯥åOKʤ鼡ءʤ۾ｪλ
     * 3. ۥȤ񤭹ǡ1ХȤ
     * 3. 񤭹᤿ɤ֤ä롣0x1ʤ񤭹0x000xffʤ
     *    񤭹ߤϤ(ԤϤ狼ʤ)
     * 4. 23ǸޤǷ֤
     * 5. Ǹ0x000xff֤äޤǼ򷫤֤
     * 6. AKI-80RAMROMӤ륳ޥɤۥȤ̤ǧ
     * 7. å׻륳ޥɤꡢХåեΥåʬ
     *    Ƿ׻
     * 餷
     */


    /* XXX Ϥ䤯褦 */

}


/* ROMΥǡɤߤƼ
 * 	COMM_SUCCEED		
 *		COMM_TRANSMIT_FAIL	ǽ
 *		COMM_RECEIVE_FAIL	ǽ
 *		COMM_NOT_AKIROM		ROM饤ĤʤäƤʤ
 *		COMM_CHECKSUM_ERROR	å२顼
 *		¾			̿˥顼ȯʼԤɥ쥹
 */
int read_receive(void)
{
    int ret;
    int receive_unit = DEFAULT_TRANSFER_UNIT;
    int cont = 1;
    int addr;

    enable_serial();
    if ((ret = send_command(AKI_READ_RECEIVE)) != COMM_SUCCEED){
	disable_serial();
	return ret;
    }

    addr = rom_addr.start;
    printf(".");
    fflush(stdout);
    /* 64ХȤž롣PC98Ǥν楽եȤϤޤȤž */
    while (cont){
	if (addr > rom_addr.end - DEFAULT_TRANSFER_UNIT){
	    cont = 0;
	    receive_unit = rom_addr.end + 1 - addr;
	}
	if (receive_serial(data_buf + addr, receive_unit) != receive_unit){
	    disable_serial();
	    return addr;	/* Ԥɥ쥹 */
	}
	addr += receive_unit;
	printf(".");
	fflush(stdout);
    }
    printf("\n");
    disable_serial();

    return checksum();
}

/* ROMΥǡȥۥȤΥǡӤ
 * 	COMM_SUCCEED		
 *		COMM_TRANSMIT_FAIL	ǽ
 *		COMM_RECEIVE_FAIL	ǽ
 *		COMM_NOT_AKIROM		ROM饤ĤʤäƤʤ
 *		COMM_CHECKSUM_ERROR	å२顼
 *		COMM_MEMOEY_ALLOC_ERROR	ݼ
 *		¾			԰ס԰פˤʤäɥ쥹
 */
int compare_host_data(void)
{
    unsigned char *buf2;
    int ret;
    int receive_unit = DEFAULT_TRANSFER_UNIT;
    int cont = 1;
    int addr;
    int i;

    if ((buf2 = (unsigned char *)malloc(DATA_BUF_SIZE)) == NULL){
	return COMM_MEMORY_ALLOC_ERROR;		/* ݼ */
    }
    /* EPROMϳƥӥåȤ1->0ˤǤʤΤǽͤ0xff */
    memset(data_buf, BLANK_DATA, DATA_BUF_SIZE);

    enable_serial();
    if ((ret = send_command(AKI_READ_RECEIVE)) != COMM_SUCCEED){
	disable_serial();
	free(buf2);
	return ret;
    }

    addr = rom_addr.start;
    printf(".");
    fflush(stdout);
    while (cont){
	if (addr > rom_addr.end - DEFAULT_TRANSFER_UNIT){
	    cont = 0;
	    receive_unit = rom_addr.end + 1 - addr;
	}
	if (receive_serial(buf2 + addr, receive_unit) != receive_unit){
	    disable_serial();
	    free(buf2);		/* XXX buf2ǤΤ? */
	    return COMM_RECEIVE_FAIL;
	}
	addr += receive_unit;
	printf(".");
	fflush(stdout);
    }
    printf("\n");
    disable_serial();

    ret = checksum();			/* åǧ */
    if (ret != COMM_SUCCEED){		/* å༺ */
	free(buf2);
	return ret;
    }
    
    /* ϤΥХåեAKI-ROM饤Хåե */
    for (i = rom_addr.start; i <= rom_addr.end; i++){
	if (buf2[i] != data_buf[i]){	/* ԰ײսȯ */
	    free(buf2);
	    return i;			/* ԰פˤʤäɥ쥹 */
	}
    }
    free(buf2);

    return COMM_SUCCEED;
}
