/* ROM˾ƤեΥۥȤǤɤ߽񤭡ХʥINTEL HEXб
 * $Id: file.c,v 1.1.1.1 2014/08/07 05:18:42 nobu-s Exp $
 */

/*
@(#)COPYRIGHT	8.2 (Berkeley) 3/21/94

The software known as AKI-ROM饤楽ե(UNIX) is distributed 
under the following terms:

Copyright (c) 1994-2014 Nobuyoshi Sato. All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:
1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.
*/

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>

#define FILE_C

#include "akirom.h"
#include "config.h"

#define OFFSET_DATANUM 1
#define OFFSET_ADDR 3
#define OFFSET_ATRIB 7
#define OFFSET_DATA 9
#define READ_SIZE 0x20


/* ΥեʤΤߤδؿ¾ϸƤФʤ */
static char *getline(char *, FILE *, int);	/* DOSήԥб */
static int hexcode2i(char *, int);		/* n16ʿʸint */
static int ishex(int);				/* 16ʿʸä鿿 */

static char *i2hexcode(char *, int, int);	/* bin -> nHEX */
static unsigned int hex_chksum(char *);
					/* HEXեѤΥå */
static int asc2int(char *);


/* n16ʸintѴ
 * 	Ѵ
 */
int hexcode2i(char *code, int n)
{
    int i;
    int ret = 0;

    for (i = 0; i < n; i++){
	ret *= 0x10;
	if (isdigit(code[i]) != 0){
	    ret += (code[i] - '0');
	} else if (('A' <= code[i]) && (code[i] <= 'F')){
	    ret += (code[i] - 'A' + 0x0a);
	} else if (('a' <= code[i]) && (code[i] <= 'f')){
	    ret += (code[i] - 'a' + 0x0a);
	}
    }
    return ret;
}

/* ȥ꡼fpbuf˰ɤ߹ࡣnХȤޤǡ
 * 	bufؤΥݥ
 */
char *getline(char *buf, FILE *fp, int n)
{
    int c;
    int i = 0;

    if((c = getc(fp)) == EOF){		/* ϤϤʤä */
	return NULL;
    }
    for (i = 0; i < n; i++){
	switch (c){
	  case EOF:			/* ǽä */
	    ungetc(c, fp);
	    buf[i] = (char)0;
	    return buf;
	  case 0x0a:			/* Ԥä */
	  case 0x0d:
	    do {
		c = getc(fp);
	    } while ((c == 0x0a) || (c == 0x0d));
	    ungetc(c, fp);
	    buf[i] = (char)0;
	    return buf;
	  default:
	    buf[i] = (char)c;
	    break;
	}
	c = getc(fp);
    }
    return buf;
}

/* ȥ꡼fp_in饤ƥHEXեɤ߹ǡ
 * data_buf˳Ǽ롣ǡΤʤɥ쥹fill_data롣
 * 	max_addr ｪλ       ɤ߹祢ɥ쥹
 *		-1	å२顼
 *		-2	HEXեǤϤʤ
 *		-3	ɥ쥹۾
 */	
int load_hex(FILE *fp_in, unsigned int fill_data)
{
    char txt_buf[255];
    int i;
    unsigned int data_num, addr, atrib;
    char sum;
    int line = 1;
    unsigned int max_addr = 0;

    for (i = 0; i < 0x8100; i++){
	data_buf[i] = (unsigned char)fill_data;
    }

    while (getline(txt_buf, fp_in, sizeof(txt_buf)) != NULL){
	if (txt_buf[0] != ':'){		/* Ԥ':'ǻϤޤäƤʤ */
	    return -2;			/* HEXեǤʤȤˤ */
	}
	i = 1;
	while (txt_buf[i] != (char)0){
	    if (ishex(txt_buf[i]) == 0){/* 16ʿʸʳޤޤƤ */
		return -2;		/* HEXեǤʤȤˤ */
	    }
	    i++;
	}
	data_num = hexcode2i(txt_buf + OFFSET_DATANUM, 2);
	addr = hexcode2i(txt_buf + OFFSET_ADDR, 4);
	atrib = hexcode2i(txt_buf + OFFSET_ATRIB, 2);
	sum = (char)0;
	i = 1;
	while (txt_buf[i] != 0){	/* å */
	    sum += hexcode2i(txt_buf + i, 2);
	    i += 2;
	}
	if (sum != 0){			/* å२顼 */
	    return -1;
	}
	if (data_num != 0){		/* ǡ0ʤ̵뤷ɤ */
	    /* 祢ɥ쥹ǧ */
	    if (max_addr < (addr + data_num - 1)){
		max_addr = addr + data_num - 1;
	    }
	    if (max_addr > 0x7fff){	/* ɥ쥹۾ */
		/* ǡΤʤԤˤϥɥ쥹ŬͤäƤ */
		return -3;	/* 顢ǡΤʤԤϹͤʤƤ */
	    }
	}
	for (i = 0; i < data_num; i++){	/* ǡǼ */
	    data_buf[addr + i] = hexcode2i(txt_buf + OFFSET_DATA + 2 * i, 2);
	}
	if (atrib == 1){		/* ǸΤϤ */
	    fwrite(data_buf, 1, max_addr + 1, fp_in);
	    return max_addr + 1;
	} else if (atrib == 0){		/* ޤ³ */
	    line++;
	    continue;
	} else {			/* ° */
	    return -2;
	}
    }
    file_loaded = YES;		/* ǡɤɤΥե饰 */
    return max_addr;
}

/* 16ʿʸĴ٤
 * 		16ʿʸ
 *			Ǥʤ
 */
int ishex(int c)
{
    if ((c >= '0') && (c <= '9')){
	return 1;
    } else if ((c >= 'A') && (c <= 'F')){
	return 1;
    } else if ((c >= 'a') && (c <= 'f')){
	return 1;
    } else {
	return 0;
    }
}

char *i2hexcode(char *hexcode, int bin, int n)
{
    int i;
    char trans_tbl[] = "0123456789abcdef";

    for (i = 0; i < n; i++){
	hexcode[n - i - 1] = trans_tbl[(bin >> (i * 4)) & 0xf];
    }
    hexcode[n] = (char)0;

    return hexcode;
}

unsigned int hex_chksum(char *buf)
{
    unsigned int sum = 0;
    int i = 0;

    while (buf[i] != (char)0){
        sum += hexcode2i(buf + i, 2);
        i += 2;
    }
    sum &= 0xff;
    return 0x100 - sum;
}

int asc2int(char *txt)
{
    int ret;

    if (txt[0] == '0'){
	if (txt[1] == 'x'){			/* 16 */
	    sscanf(txt + 2, "%x", &ret);
	} else {				/* 8 */
	    sscanf(txt + 1, "%o", &ret);
	}
    } else {					/* 10 */
	sscanf(txt, "%d", &ret);
    }

    return ret;
}

/* data_bufnХȤ򥹥ȥ꡼fp_out˽񤭹
 * 	total	ｪλ 񤭹Хȿ
 */
int save_hex(FILE *fp_out, unsigned int total)
{
    unsigned int write_size = 0;	/* 񤭹 */
    unsigned int bytes_per_line = READ_SIZE;
    int i;
    char text_buf[100];
    unsigned int f;

    while (write_size < total){
	if (total - write_size < READ_SIZE){
	    bytes_per_line = total - write_size;
	}
	for (i = 0; i < 100; i++){
	    text_buf[i] = '\0';
	}
	text_buf[0] = ':';
	i2hexcode(text_buf + OFFSET_DATANUM, bytes_per_line, 2);
	i2hexcode(text_buf + OFFSET_ADDR, write_size, 4);
	i2hexcode(text_buf + OFFSET_ATRIB, 0, 2);
	for (i = 0; i < bytes_per_line; i++){
	    i2hexcode(text_buf + OFFSET_DATA + i * 2, data_buf[write_size + i],
		      							2);
	}
	i2hexcode(text_buf + OFFSET_DATA + bytes_per_line * 2,
		  hex_chksum(text_buf + 1), 2);
	strcat(text_buf, "\x0d\x0a");
	fputs(text_buf, fp_out);
	write_size += bytes_per_line;
    }
    for (i = 0; i < 100; i++){
	text_buf[i] = '\0';
    }
    text_buf[0] = ':';
    i2hexcode(text_buf + OFFSET_DATANUM, 0, 2);
    i2hexcode(text_buf + OFFSET_ADDR, 0, 4);
    i2hexcode(text_buf + OFFSET_ATRIB, 1, 2);
    
    f = hex_chksum(text_buf + 1);
    i2hexcode(text_buf + OFFSET_DATA, f, 2);
    strcat(text_buf, "\x0d\x0a");
    fputs(text_buf, fp_out);
    fflush(fp_out);

    return total;
}

/* ȥ꡼fp_indata_bufɤ߹ࡣ
 * 	-1	
 *		ʳ ɤߤХȿ
 */
int load_bin(FILE *fp_in, unsigned int filldata)
{
    int n;
    int i;
    int read_bytes = 0;

    for (i = 0; i < 0x8100; i++){
	data_buf[i] = (unsigned char)filldata;
    }
    while ((n = fread(data_buf + read_bytes, 1, 256, fp_in)) > 0){
	read_bytes += n;
    }
    file_loaded = YES;		/* ǡɤɤΥե饰 */

    return read_bytes;
}

/* ȥ꡼fp_outdata_bufnХȽ񤭹
 * 	-1	
 *		ʳ 񤭹Хȿ
 */
int save_bin(FILE *fp_out, unsigned int n)
{
    return fwrite(data_buf, 1, n, fp_out);
}
