/* /ޥɤβϤȥޥɽcommunicate.cδؿ˸Ƥ
 * $Id: main.c,v 1.1.1.1 2014/08/07 05:18:42 nobu-s Exp $
 */
/*
@(#)COPYRIGHT	8.2 (Berkeley) 3/21/94

The software known as AKI-ROM饤楽ե(UNIX) is distributed 
under the following terms:

Copyright (c) 1994-2014 Nobuyoshi Sato. All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:
1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.
*/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <string.h>

#define MAIN_C
#include "akirom.h"
#include "config.h"



/* Хѿ */
unsigned char *data_buf = NULL;	/* եؤΥǡɤ߽ѤΥХåե */
int rom_type = AKI_ROM_NONE;	/* ǥեȤROM */
int file_format = FILE_FORMAT_NONE;
char *file_name = NULL;		/* ɤ߽񤭤ΤΥե̾ */
char *dev_name = NULL;		/* AKI-ROM饤³ꥢݡ */
int operation = OPERATION_NONE;	/* ROM饤Ф */

struct ROM_ADDR rom_addr = { 0x0, 0x7fff }; /* ROM񤭹ߤγϽλɥ쥹 */
int file_loaded = NO;		/* ǡɤ */
/* XXX CLIǤǤAKI-80RAM˥ǡ뤫ɤϥåǤʤ*/
/*int akiram_loaded = NO;		/* AKI80RAM˥ǡ뤫 */


/* ΥץϥꥢݡȤؤν񤭹߸¤桼/롼פ
 * setuid,setgid뤳ȤꤷƤ
 */
uid_t ruid;			/* 桼ID */
uid_t euid;			/* ¸桼ID */
uid_t rgid;			/* 롼ID */
uid_t egid;			/* ¸롼ID */

static void show_help(void);
static int parse_args(int argc, char *argv[]);

int main(int argc, char *argv[])
{
    if (!parse_args(argc, argv)){
	show_help();
	return 1;
    }
    init_all();

    do_operation();

    end_all();

    return 0;
}


/* ǻꤵ줿¹Ԥ롣
 * ֤	1	
 *		0	
 */
int do_operation(void)
{
    FILE *fp = NULL;
    int result = -1;

    if (rom_type == AKI_ROM_NONE){
	fprintf(stderr, "ROM type is not specified. Exit.\n");
	return 0;
    }

    /* ʳꤵ줿եɤ߹ */
    if (operation == OPERATION_TRANSMIT ||
	operation == OPERATION_TRANSMIT_WRITE ||
	operation == OPERATION_COMPARE_HOST ||
	operation == OPERATION_CHECKSUM){
	if (file_name == NULL){
	    fprintf(stderr, "Filename required for specified operation."
		    " Use -h filename or -b filename to specify file.\n");
	    return 0;
	}
	if ((fp = fopen(file_name, "r")) == NULL){
	    fprintf(stderr, "Cannot load input file %s. Exit.\n", file_name);
	    fclose(fp);
	    return 0;
	}
	if (file_format == FILE_FORMAT_HEX){
	    load_hex(fp, BLANK_DATA);
	} else if (file_format == FILE_FORMAT_BIN){
	    load_bin(fp, BLANK_DATA);
	} else {
	    fprintf(stderr, "Incorrect file format. Exit\n");
	    fclose(fp);
	    return 0;
	}
	fclose(fp);
	fp = NULL;
	file_loaded = YES;
    }
	
    /* AKI-ROM饤Ф륳ޥɼ¹ */
    switch (operation){
      case OPERATION_TRANSMIT:
	if (file_loaded != YES){
	    fprintf(stderr, "Data file is not loaded.\n");
	    return 0;
	}
	result = trans_aki_ram();
	if (result >= 0){
	    printf("Transmit to AKI-ROM writer's RAM failed at address "
		   "0x%04hx.\n", (unsigned short)result);
	    return 0;
	}
	printf("Transmitting to AKI-ROM writer's RAM succeeded.\n");
	break;
      case OPERATION_TRANSMIT_WRITE:
	/* XXX   */
	result = transmit_write();
	
	break;
      case OPERATION_WRITE:
	result = write_aki_ram();
	if (result >= 0){
	    printf("Writing ROM from AKI-ROM writer's RAM failed at address "
		   "0x%04hx.\n", (unsigned short)result);
	    return 0;
	}
	printf("Writtin ROM succeeded.\n");
	break;
      case OPERATION_READ:
	result = read_aki_ram();
	if (result >= 0){
	    printf("Read ROM to AKI-ROM writer's RAM failed at address "
		   "0x%04hx.\n", (unsigned short)result);
	    return 0;
	}
	printf("Reading ROM to AKI-ROM writer's RAM succeeded.\n");
	break;
      case OPERATION_READ_RECEIVE:
	result = read_receive();
	if (result >= 0){
	    printf("Communication to AKI-ROM writer failed at address "
		   "0x%04hx.\n", (unsigned short)result);
	    return 0;
	}
	printf("Read from ROM to a file succeeded.\n");
	break;
      case OPERATION_COMPARE:
	result = compare_aki_ram();
	printf("Compare ROM and AKI-ROM writer's RAM succeeded.\n");
	break;
      case OPERATION_COMPARE_HOST:
	result = compare_host_data();
	if (result >= 0){
	    printf("Comparison mismatch at address 0x%04hx.\n", 
						(unsigned short)result);
	    return 0;
	}
	printf("Compare file and AKI-ROM writer's RAM succeeded.\n");
	break;
      case OPERATION_BLANK_CHECK:
	result = blank_check();
	if (result >= 0){
	    printf("ROM is not blank at address 0x%04hx.\n", 
						(unsigned short)result);
	    return 0;
	}
	printf("ROM is blank.\n");
	break;
      case OPERATION_CHECKSUM:
	result = checksum();
	if (result >= 0){
	    printf("Checksum mismatch at address 0x04hx.\n",
						(unsigned short)result);
	    return 0;
	}
	printf("Checksum match.\n");
	break;
      default:
	fprintf(stderr, "Invalid operation. Contact author.\n");
	return 0;
    }

    if (result < COMM_SUCCEED){
	switch (result){
	  case COMM_TRANSMIT_FAIL:
	    fprintf(stderr, "Couldn't send command to AKI-ROM writer.\n");
	    break;
	  case COMM_RECEIVE_FAIL:
	    fprintf(stderr, "Coundn't receive from AKI-ROM writer.\n");
	    break;
	  case COMM_NOT_AKIROM:
	    fprintf(stderr, "Connected device is not AKI-ROM writer.\n");
	    break;
	  case COMM_CHECKSUM_ERROR:
	    fprintf(stderr, "Check sum error.\n");
	    break;
	  case COMM_MEMORY_ALLOC_ERROR:
	    fprintf(stderr, "Couldn't allocate memory.\n");
	    break;
	  default:
	    fprintf(stderr, "Contact author. Here should not be reached\n");
	    break;
	}

	return 0;		/*  */
    }

    
    /* ե¸ʤ */
    if (operation == OPERATION_RECEIVE ||
	operation == OPERATION_READ_RECEIVE){
	if (file_name == NULL){
	    fprintf(stderr, "Filename required for specified operation."
		    " Use -h filename or -b filename to specify file.\n");
	    return 0;
	}
	if ((fp = fopen(file_name, "w")) == NULL){
	    fprintf(stderr, "Cannot open output file %s. Exit.\n", file_name);
	    fclose(fp);
	    return 0;
	}
	if (file_format == FILE_FORMAT_HEX){
	    save_hex(fp, rom_addr.end - rom_addr.start + 1);
	} else if (file_format == FILE_FORMAT_BIN){
	    save_bin(fp, rom_addr.end - rom_addr.start + 1);
	} else {
	    fprintf(stderr, "Incorrect file format. Exit\n");
	    fclose(fp);
	    return 0;
	}
	fclose(fp);
	fp = NULL;
    }
    
    return 1;
}

/* Ϥɬפѿ/Хåեʤɤ򥻥åȤ
 * 		argc	main()argc
 *		argv	main()argv
 * ֤	1	operationμ¹Ԥɬפʾ·ä
 *		0	operationʤץ­
 */
int parse_args(int argc, char *argv[])
{
    int i, len;

    if (argc < 4){		/* operation-d̤ */
	return 0;
    }
    
    /* 2Ͼoperation */
    if (strcmp(argv[1], "transmit") == 0){
	operation = OPERATION_TRANSMIT;
    } else if (strcmp(argv[1], "transmitwrite") == 0){
	operation = OPERATION_TRANSMIT_WRITE;
    } else if (strcmp(argv[1], "write") == 0){
	operation = OPERATION_WRITE;
    } else if (strcmp(argv[1], "read") == 0){
	operation = OPERATION_READ;
    } else if (strcmp(argv[1], "receive") == 0){
	operation = OPERATION_RECEIVE;
    } else if (strcmp(argv[1], "readreceive") == 0){
	operation = OPERATION_READ_RECEIVE;
    } else if (strcmp(argv[1], "compare") == 0){
	operation = OPERATION_COMPARE;
    } else if (strcmp(argv[1], "comparehost") == 0){
	operation = OPERATION_COMPARE_HOST;
    } else if (strcmp(argv[1], "blankcheck") == 0){
	operation = OPERATION_BLANK_CHECK;
    } else if (strcmp(argv[1], "checksum") == 0){
	operation = OPERATION_CHECKSUM;
    } else {
	fprintf(stderr, "cannot recogonize operation %s\n", argv[1]);
	return 1;			/* Ǥʤ */
    }

/*    printf("operation = %d\n", operation);*/

    for (i = 2; i < argc; i++){
	if (argv[i][0] == '-' && i < argc - 1){
	    switch(argv[i][1]){
	      case 'd':
		i++;
		if ((dev_name = malloc(strlen(argv[i]) + 1)) == NULL){
		    goto error;
		}
		strcpy(dev_name, argv[i]);
		break;
	      case 'h':
		i++;
		if ((file_name = malloc(strlen(argv[i]) + 1)) == NULL){
		    goto error;
		}
		strcpy(file_name, argv[i]);
		file_format = FILE_FORMAT_HEX;
		break;
	      case 'b':
		i++;
		if ((file_name = malloc(strlen(argv[i]) + 1)) == NULL){
		    goto error;
		}
		strcpy(file_name, argv[i]);
		printf("file_name = %s\n", file_name);
		file_format = FILE_FORMAT_BIN;
		break;
	      case 'r':
		i++;
		if (strcmp(argv[i], "2764") == 0){
		    rom_type = AKI_ROM_2764;
		    rom_addr.end = 0x1fff;
		} else if (strcmp(argv[i], "27128") == 0){
		    rom_type = AKI_ROM_27128;
		    rom_addr.end = 0x3fff;
		} else if (strcmp(argv[i], "27256") == 0){
		    rom_type = AKI_ROM_27256;
		    rom_addr.end = 0x7fff;
		} else if (strcmp(argv[i], "2864") == 0){
		    rom_type = AKI_ROM_2864;
		    rom_addr.end = 0x1fff;
		} else {
		    goto error;
		}
		break;
	      default:
		goto error;
	    }
	} else {
	    goto error;
	}

    }

/*
    if (dev_name != NULL){
	printf("dev_name = %s\n", dev_name);
    }
    if (file_name != NULL){
	printf("file_name = %s, file_format = %d\n", file_name, file_format);
    }
    printf("romtype = %x\n", rom_type);
*/

    return 1;

 error:
    end_all();		/* malloc()곫ǥХ򥯥 */

    return 0;
}

/* إפɽ
 * 		ʤ
 * ֤	ʤ
 */
void show_help(void)
{
    printf("akirom: a AKI-ROM writer controller.\n");
    printf("usage: akirom operation [options]\n");
    printf("Operation is one of:\n");
    printf("  transmit:      Transmit a HEX/binary file to AKI-ROM writer.\n");
/*    printf("  transmitwrite: Transmit a HEX/binary file to AKI-ROM write, "
      "and rwite to ROM\n");*/
    printf("  write:         Write AKI-ROM writer's RAM data to ROM.\n");
    printf("  read:          Read ROM to AKI-ROM writer's RAM.\n");
    printf("  receive:       Receive a data on AKI-ROM writer's RAM.\n");
    printf("  readreceive:   Read ROM to AKI-ROMwriter's RAM, and receive "
	   "data.\n");
    printf("  compare:       Compare AKI-ROM writer's RAM and ROM.\n");
    printf("  comparehost:   Compare ROM and a file on host.\n");
    printf("  blankcheck:    Check whether ROM is erased.\n");
    printf("  checksum:      Compare chacksum of ROM and file on host.\n");
    printf("Options are:\n");
    printf("  -d devfile:   Device file for serial port. Always required\n");
    printf("  -h filename:  Specify Intel HEX file.\n");
    printf("  -b filename:  Specify binary file.\n");
    printf("  One of two options avobe is required for transmit, ");
    printf("transmitwrite, receive, \n");
    printf("  readreceive, checksum operation.\n");
    printf("  -r romtype\n");
    printf("  The romtype option is one of 2764, 27128, 27256, 2864\n");
    printf("  The romtype option is required for transmitwrite, write, read, "
	   "readreceive,\n  compare and comparehost operation.\n");
    printf("  -s start end: Specify start and end address to wtite ROM in "
	   "HEX.\n");
}

/* ѿ롣¹Գϻ˰٤Ƥ֤ȡ
 * ʥ⤳ǹԤ
 * 	0	ｪλ
 */
int init_all(void)
{
    int i;

    /* ǡѤΥХåեݤƽ */
    if ((data_buf = (unsigned char *)malloc(DATA_BUF_SIZE)) == NULL){
	fprintf(stderr, "Can't alocate buffer memory.\n");
	exit(1);
    }
    /* EPROMϳƥӥåȤ1->0ˤǤʤΤǽͤ0xff */
    memset(data_buf, BLANK_DATA, DATA_BUF_SIZE);

    ruid = getuid();		/* 桼롼ID碌 */
    euid = geteuid();		/* set-user-idƤ硢euid,egidˤ */
    rgid = getgid();		/* ¸եνͭԤID */
    egid = getegid();
    setreuid(-1, ruid);		/* euid,egidruid,rgidˤ */
    setregid(-1, rgid);

    enable_setugid();		/* ꥢ饤 */
    if (init_serial(dev_name) < 0){
	fprintf(stderr, "Could not open %s.\n", dev_name);
	exit(1);
    }
    disable_setugid();

    return 0;
}

/* ¸桼IDset-user-id,set-group-id줿ID˹碌 */
void enable_setugid(void)
{
    setreuid(-1, euid);
    setregid(-1, egid);
}

/* ¥桼˼¸桼롼ID碌 */
void disable_setugid(void)
{
    setreuid(-1, ruid);
    setregid(-1, egid);
}

/* λ
 * 	0	ｪλ
 */
int end_all(void)
{
    enable_setugid();
    close_serial();
    disable_setugid();
    if (data_buf != NULL){
	free(data_buf);
    }
    if (file_name != NULL){
	free(file_name);
    }
    if (dev_name != NULL){
	free(dev_name);
    }

    return 0;
}
