/* ꥢݡȤ٥
 * $Id: serial.c,v 1.1.1.1 2014/08/07 05:18:42 nobu-s Exp $
 */


/*
@(#)COPYRIGHT	8.2 (Berkeley) 3/21/94

The software known as AKI-ROM饤楽ե(UNIX) is distributed 
under the following terms:

Copyright (c) 1994-2014 Nobuyoshi Sato. All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:
1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.
*/

#include <sys/ioctl.h>
#include <sys/time.h>
#include <sys/file.h>
#include <termios.h>
#include <string.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/uio.h>
#include <unistd.h>
#include <setjmp.h>
#include <signal.h>
#include <string.h>
#include <errno.h>

#define SERIAL_C
#include "akirom.h"
#include "config.h"

struct LOCK {
    char name[512];
    FILE *fp;
    int fd;
    int created;
};

/* ΥեǤΤߤѿ¾ϸƤФʤ */
static int sio = -1;
static struct termios term;
static struct termios term_save;
static int ldisc;
static int ldisc_save;
static int line_state;
static struct LOCK lockfile;
static jmp_buf jmp_env;


/* ΥեǤΤߤδؿ */
static void sig_alarm(int);


/* *dev		ꥢݡȤΥǥХե̾
 * 	-1	sioץ
 *		-2	åե뤬ˤ
 *		-3	åե
 *		-4	å
 *		>= 0	 եǥץ
 */
int init_serial(char *dev)
{
    char buf[256];

    lockfile.created = 0;
    lockfile.fd = -1;
    if (dev[0] == '/'){
	strncpy(lockfile.name, dev, sizeof(lockfile.name));
	strncat(lockfile.name, LOCKFILE_TAIL, sizeof(lockfile.name));
    } else {
	snprintf(lockfile.name, sizeof(lockfile.name), LOCKFILE, dev);
    }

    if ((lockfile.fp = fopen(lockfile.name, "r")) == NULL){
	/* åե뤬ʤ -> ̵к */
	if ((lockfile.fp = fopen(lockfile.name, "w")) == NULL){
	    
	    perror("init_serial(): Cannot create lockfile");
	    return -3;			/* åե */
	}
	lockfile.created = 1;
    }
    lockfile.fd = fileno(lockfile.fp);

    /* flock() */
    if (flock(lockfile.fd, LOCK_EX) != 0){
	perror("init_serial(): Cannot lock lockfile.\n");

	return -4;
    }

    if (dev[0] != '/'){			/* եѥǻꤵƤʤ */
	strncpy(buf, "/dev/", sizeof(buf));
	strncat(buf, dev, sizeof(buf));
    } else {
	strncpy(buf, dev, sizeof(buf));
    }

    if ((sio = open(buf, O_RDWR | O_APPEND, 0600)) < 0){
	return sio;
    }
    ldisc = TTYDISC;			/* termios  */
    ioctl(sio, TIOCGETD, &ldisc_save);
    ioctl(sio, TIOCSETD, &ldisc);
    ioctl(sio, TIOCGETA, &term_save);
    term = term_save;
    					/* termΥС¾ˤ⤢ */
    term.c_iflag = term.c_oflag = term.c_lflag = term.c_cflag = 0;

/* c_iflag	8ӥåȥ롼
 *		BREAK̵
 *		BREAKSIGINTRȯʤ
 *		ѥƥ顼̵
 * c_oflag	ϼνϹԤʤ
 * c_cflag	
 *  		8bit Υѥƥ ȥåץӥå1bit
 *		ϡɥե
 *		ǥॹơ饤̵
 * 		9600bps
 */
    term.c_iflag &= ~(ISTRIP | BRKINT);
    term.c_iflag |= (IGNBRK | IGNPAR);
    term.c_oflag &= ~(OPOST);
    term.c_cflag |= (CS8 | CREAD | CRTSCTS | CLOCAL);
    term.c_lflag = 0;
    term.c_cc[VMIN] = 0;		/* ǤʤȤǤ2ä */
    term.c_cc[VTIME] = 20;		/* ƥॳ뤫 */
    term.c_ispeed = B9600;
    term.c_ospeed = B9600;
    ioctl(sio, TIOCSETA, &term);

    ioctl(sio, TIOCMGET, &line_state);		/* 濮ξ֤ */
    return sio;
}


/* ꥢ饤򥯥
 * 	0	
 *		-1	
 *		-2	åե
 *		-3	å
 */
int close_serial(void)
{
    if (sio < 0){		/* ꥢ饤󤬥ץ󤵤Ƥʤ */
	return -1;
    }
    
    ioctl(sio, TIOCSETA, &term_save);

    if (!flock(lockfile.fd, LOCK_UN)){		/* å */
	return -3;
    }
    fclose(lockfile.fp);
    lockfile.fd = -1;
    if (lockfile.created == 1){
	if (unlink(lockfile.name) != 0){	/* åե */
	    return -2;
	}
    }


    return close(sio);
}


/* ꥢ饤Ȥ褦ˤƼ¸桼롼IDset-user-id
 * set-group-id줿ID˹碌
 * DTRRTS򥪥ˤ
 */
void enable_serial(void)
{
    line_state |= (TIOCM_DTR | TIOCM_RTS);
    ioctl(sio, TIOCMSET, &line_state);
}


/* ꥢ饤ߤƼ¸桼롼ID򸵤᤹
 * DRTRTS򥪥դˤ
 */
void disable_serial(void)
{
    line_state &= ~(TIOCM_DTR | TIOCM_RTS);
    ioctl(sio, TIOCMSET, &line_state);
}

/* ॢ2
 * *data	񤭹
 * n		Хȿ
 * 	n	
 *		-1	ƥॳ뼺
 *		0	ॢ
 */
int receive_serial(unsigned char *data, unsigned int n)
{
    int i;
    int result;

    for (i = 0; i < n; i++){
	if ((result = read(sio, data + i, 1)) == 0){	/* ॢ */
	    return 0;
	}
    }
    return n;
}

/* ǡƤ뤫
 * 	0	Ƥʤ
 *		1	Ƥ
 *		-1	select()
 */
int check_rxbuf_serial(void)
{
    fd_set readfds;
    struct timeval timeout;

    FD_ZERO(&readfds);
    FD_SET(sio, &readfds);
    timeout.tv_sec = 0;
    timeout.tv_usec = 0;
    
    return select(1, &readfds, NULL, NULL, &timeout);
}

/* ॢȤϹͤʤ
 * 
 * *data	񤭹
 * n		Хȿ
 * 	n	
 *		0	ॢ
 *		-1	ƥॳ뼺
*/
int trans_serial(unsigned char *data, unsigned int n)
{
    int i;
    int result;
    int txbuf_remain;
    void (*sig_save)(int);

    sig_save = signal(SIGALRM, sig_alarm);
    for (i = 0; i < n; i++){
	if (setjmp(jmp_env) == 0){
	    alarm(2);
	    while (1){				/* ơ饤Ĵ٤ */
		ioctl(sio, TIOCMGET, &line_state);
		if ((line_state & (TIOCM_CTS | TIOCM_CD | TIOCM_DSR)) 
				    == TIOCM_CTS | TIOCM_CD | TIOCM_DSR){
		    ioctl(sio, TIOCOUTQ, &txbuf_remain);
		    if (txbuf_remain < 16){
			break;			/* ǽ */
		    }
		}
	    }
	    alarm(0);		/* 顼 */
	} else {		/* longjmp()ˤꡣॢȤ */
	    signal(SIGALRM, sig_save);
	    return 0;
	}
	result = write(sio, data + i, 1);	/*  */
/*	printf("Write SIO result = %d\n", result);*/
    }
    signal(SIGALRM, sig_save);
    return n;
}

static void sig_alarm(int a)		/* եΤߤΥ */
{
    longjmp(jmp_env, 1);
}
